unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  ComCtrls, fphttpclient, LConvEncoding, sax_html, dom_html, dom, strutils;

type

  { TForm1 }

  TForm1 = class(TForm)
    ListView1: TListView;
    btnStart: TButton;
    edUrl: TEdit;
    Panel1: TPanel;
    procedure btnStartClick(Sender: TObject);
    procedure ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: boolean);
    procedure ListView1AdvancedCustomDrawSubItem(Sender: TCustomListView;
      Item: TListItem; SubItem: integer; State: TCustomDrawState;
      Stage: TCustomDrawStage; var DefaultDraw: boolean);
  private

  public
    function ClearLine(s: string): string;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }



procedure TForm1.btnStartClick(Sender: TObject);
var
  httpclient: TFPHTTPClient;
  html: string;
  doc: thtmldocument;
  nlist: tdomnodelist;
  i: integer;
  j: integer;
  s: string;
begin
  httpclient := TFPHttpClient.Create(nil);
  httpclient.AddHeader('User-Agent',
    'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0');
  try
    html := httpclient.Get(edUrl.Text);
  finally
    httpclient.Free;
  end;
 // если не юникод
 //  readhtmlfile(doc, tstringstream.Create(CP1251ToUTF8(html)));

  readhtmlfile(doc, tstringstream.Create(html));
  nlist := doc.GetElementsByTagName('div');
  ListView1.Items.BeginUpdate;
  for i := 0 to nlist.Count - 1 do
  begin
    if (tdomelement(nlist[i]).getattribute('class') = 'ranked-team standard-box') then
    begin
      with ListView1.Items.Add do
      begin
        Caption := nlist[i].ChildNodes[1].ChildNodes[1].ChildNodes[0].TextContent;
        SubItems.Add(nlist[i].ChildNodes[1].ChildNodes[1].ChildNodes[3].ChildNodes[1].ChildNodes[0].TextContent);
        SubItems.Add(nlist[i].ChildNodes[1].ChildNodes[1].ChildNodes[3].ChildNodes[1].ChildNodes[1].TextContent);
        SubItems.Add(ClearLine(nlist[i].ChildNodes[1].ChildNodes[1].ChildNodes[3].ChildNodes[3].TextContent));
        SubItems.Add(nlist[i].ChildNodes[1].ChildNodes[1].ChildNodes[7].ChildNodes[0].TextContent);
      end;
    end;

  end;
  ListView1.Items.EndUpdate;
  nlist.Free;
  doc.Free;
end;

procedure TForm1.ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
  var DefaultDraw: boolean);
begin

end;

procedure TForm1.ListView1AdvancedCustomDrawSubItem(Sender: TCustomListView;
  Item: TListItem; SubItem: integer; State: TCustomDrawState;
  Stage: TCustomDrawStage; var DefaultDraw: boolean);
begin
  if listview1.Items.Count = 0 then
    exit;
  if item.SubItems[3] <> '-' then
  begin
    if subitem = 4 then
    begin
      if pos('-', item.SubItems[3]) > 0 then
        Sender.Canvas.Brush.Color := $003737FF;

      if pos('+', item.SubItems[3]) > 0 then
        Sender.Canvas.Brush.Color := $0064FFB1;

    end;
  end;



end;

function TForm1.ClearLine(s: string): string;
var
  s1: string;
  s2: string;
begin
  s1 := StringReplace(s, #13#10, '', [rfReplaceAll]);
  s2 := StringReplace(s1, '    ', ' ', [rfReplaceAll]);
  Result := trim(StringReplace(s2, '  ', ' ', [rfReplaceAll]));
end;

end.
